<?php
/*******************************************************************************/
//                          InstantCMS v1.10                                    //
//                      http://www.instantcms.ru/                              //
//                      module "Friends of friends"  v 1.3.0                   //
//                        written by Marat Fatikhov                            //
//                      (nickname Марат on a site)                             //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/********************************************************************************/

Error_Reporting(E_ALL & ~E_NOTICE & ~E_WARNING);

header('Content-Type: text/html; charset=utf-8');
session_start();

define("VALID_CMS", 1);
define('PATH', $_SERVER['DOCUMENT_ROOT']);

include(PATH.'/core/cms.php');

$inCore = cmsCore::getInstance();

cmsCore::loadClass('page');
$inCore->loadClass('db');
$inCore->loadClass('user');

$inDB   = cmsDatabase::getInstance();
$inUser = cmsUser::getInstance();

$inUser->update();

$my_id = $inUser->id;
$user_id  = $inCore->request('user_id', 'int', 0);

if(!$my_id || !$user_id || $user_id == $my_id){ return;}

//получаем список друзей авторизованного пользователя
$my_friends = cmsUser::getFriends($my_id);

//получаем список друзей пользователя, с которым общие друзья(только id)
$sql = "SELECT
        CASE
			WHEN f.from_id = $user_id
			THEN f.to_id
			WHEN f.to_id = $user_id
			THEN f.from_id
			END AS user_id
      FROM cms_user_friends f
      WHERE (f.from_id = '$user_id' OR f.to_id = '$user_id') AND is_accepted =1";

$result = $inDB->query($sql);
if(!$inDB->num_rows($result)){return false;}

$user_friends = array();
while($friend = $inDB->fetch_assoc($result)){
   $user_friends[] = $friend['user_id'];
}

$friends = array();
foreach($my_friends as $key=>$value){
   //если общий друг, заносим в массив
   if(in_array($value['id'], $user_friends)){
       $friends[] =  $value;
   }
}

$is_general = true;

//передаем в шаблон
$smarty = cmsPage::initTemplate('modules', 'mod_friends_of_friends_popup.tpl');
$smarty->assign('friends', $friends);
$smarty->assign('is_general', $is_general);
$smarty->display('mod_friends_of_friends_popup.tpl');

return;
?>
